<template>
    <div>
        <p class="text-left">
            Enter the password reset verification code you received from the email.
        </p>

        <ValidationObserver v-slot="{ handleSubmit }">
            <form @submit.prevent="handleSubmit(onResetPassword)">
                <div class="mt-4">
                    <ValidationProvider
                        v-slot="{ errors }"
                        name="email"
                        rules="required|email"
                    >
                        <input
                            id="email"
                            v-model="email"
                            class="form-control"
                            name="email"
                            placeholder="Email"
                            type="email"
                        />
                        <div class="error-message">{{ errors[0] }}</div>
                    </ValidationProvider>
                </div>

                <div class="mt-4">
                    <ValidationProvider
                        v-slot="{ errors }"
                        name="new passsword"
                        rules="required"
                    >
                        <input
                            id="new-password"
                            v-model="newPassword"
                            class="form-control"
                            name="new_password"
                            placeholder="New Password"
                            type="password"
                        />
                        <div class="error-message">{{ errors[0] }}</div>
                    </ValidationProvider>
                </div>

                <div class="mt-4">
                    <ValidationProvider
                        v-slot="{ errors }"
                        name="verification code"
                        rules="required|numeric"
                    >
                        <input
                            id="verification-code"
                            v-model="verificationCode"
                            class="form-control"
                            name="verification_code"
                            placeholder="Verification Code"
                            type="text"
                        />
                        <div class="error-message">{{ errors[0] }}</div>
                    </ValidationProvider>
                </div>

                <div class="mt-4">
                    <button class="btn btn-fluid text-uppercase" type="submit">
                        Submit
                    </button>
                </div>
            </form>
        </ValidationObserver>

        <div class="mt-4">
            <a href="#" @click="switchComponent('LoginForm')">
                <font-awesome-icon icon="chevron-left"/>
                Back to login </a>
        </div>
    </div>
</template>

<script>

import UserService from "@/services/UserService";

export default {
    name: "reset-password-form-component",
    data() {
        return {
            email: "",
            newPassword: "",
            verificationCode: "",
        };
    },
    methods: {
        /**
         * Show loading overlay.
         */
        showLoadingOverlay() {
            this.$JsLoadingOverlay.show({'spinnerIcon': 'ball-scale-multiple'});
        },

        /**
         * Hide loading overlay.
         */
        hideLoadingOverlay() {
            this.$JsLoadingOverlay.hide();
        },

        /**
         * Reset user password.
         */
        onResetPassword() {
            this.showLoadingOverlay();

            let vm = this;

            // Send reset password email to user.
            this.userService.resetPassword(this.email, this.newPassword, this.verificationCode).then((result) => {
                this.hideLoadingOverlay();

                if (result.status !== 200) {
                    let message = 'Oops! Something went wrong.';

                    if (result.response !== undefined) {
                        message = result.response.data.message;
                    }

                    vm.$swal({
                        title: "Error!",
                        text: message,
                        icon: "error",
                        confirmButtonText: "OK"
                    });
                } else {
                    vm.$swal({
                        title: "Success",
                        text: "Successfully reset your password.",
                        icon: "success",
                    }).then(function () {
                        vm.switchComponent('LoginForm');
                    });
                }
            });
        },

        /**
         * Switch component.
         *
         * @param componentName
         */
        switchComponent(componentName) {
            this.$emit("switchComponent", componentName);
        }
    },
    computed: {
        /**
         * Create UserService instance.
         *
         * @returns {UserService}
         */
        userService: function () {
            return new UserService(true);
        }
    },
};
</script>

<style lang="scss" scoped>
@import "../../assets/styles/pages/authentication/auth.scss";
</style>
